PROGRAM WriteBootSector;
VAR
  DiskSectorsPerTrack,
  DiskTracksPerHead,
  DiskHeads : WORD;

FUNCTION WriteSector(Sector : WORD; Buffer : POINTER) : BYTE; ASSEMBLER;
ASM
  mov CX, Sector
  mov AX, CX
  xor DX, DX
  div [DiskSectorsPerTrack]
  mov CL, DL                    { Set the sector                            }
  and CL, 63                    { Top two bits are bits 8&9 of the cylinder }
  xor DX, DX
  div [DiskTracksPerHead]
  mov CH, DL                    { Set the track bits 0-7                    }
  mov AL, DH
  ror AL, 1
  ror AL, 1
  and AL, 11000000b
  or CL, AL                     { Set bits 8&9 of track                     }
  xor DX, DX
  div [DiskHeads]
  mov DH, DL                    { Set the head                              }
  inc CL

  mov SI, 4
@TryAgain:
  mov AL, 1
  les BX, Buffer
  mov DL, 0
  mov AH, 3
  int 13h
  jnc @Done
  dec SI
  jnz @TryAgain

@Done:
  mov AL, AH
END;

TYPE
  ByteArray = ARRAY[0..0] OF BYTE;
VAR
  Buffer : ^ByteArray;
  F      : File;
  Error  : INTEGER;
  StartSec : INTEGER;
  I : BYTE;
BEGIN
  DiskHeads := 2;
  DiskTracksPerHead := 80;
  DiskSectorsPerTrack := 18;

  IF ParamCount < 2 THEN
  BEGIN
    WRITELN('Syntax:');
    WRITELN('  CopyBoot Filename.EXE Starting sector');
    HALT;
  END;

  ASM
    mov AH, 0
    mov DL, 0
    int 13h     { Reset drive A }
  END;

  GETMEM(Buffer, 512);
  ASSIGN(F, ParamStr(1));
  RESET(F, 1);
  VAL(ParamStr(2), StartSec, Error);
  I := StartSec;
  Error := 0;
  WHILE (NOT EOF(F)) AND (Error = 0) DO
  BEGIN
    FillChar(Buffer^, 512, 0);
    BlockRead(F, Buffer^, 512, Error);
    Error := WriteSector(I, Buffer);
    INC(I);
  END;
  CLOSE(F);

  IF Error <> 0 THEN
    WRITELN('Error #', Error, ' writting sector #', I-1)
  ELSE
    WRITELN(I-StartSec, ' sectors copied successfully!!!');
END.